package com.eclipse.listener.helpClasses;

import java.awt.Toolkit;
import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.StringSelection;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;

import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.commands.NotEnabledException;
import org.eclipse.core.commands.NotHandledException;
import org.eclipse.core.commands.common.NotDefinedException;
import org.eclipse.core.resources.IFile;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.jdt.internal.ui.util.SWTUtil;
import org.eclipse.jface.action.ActionContributionItem;
import org.eclipse.jface.action.IContributionItem;
import org.eclipse.jface.action.MenuManager;
import org.eclipse.jface.bindings.Binding;
import org.eclipse.jface.bindings.keys.IKeyLookup;
import org.eclipse.jface.bindings.keys.KeyBinding;
import org.eclipse.jface.bindings.keys.SWTKeyLookup;
import org.eclipse.jface.bindings.keys.SWTKeySupport;
import org.eclipse.jface.commands.ActionHandler;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.internal.MenuManagerEventHelper;
import org.eclipse.jface.wizard.IWizard;
import org.eclipse.jface.wizard.WizardDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.MenuEvent;
import org.eclipse.swt.events.MenuListener;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.internal.win32.OS;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Decorations;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.ToolBar;
import org.eclipse.swt.widgets.ToolItem;
import org.eclipse.swt.widgets.Tree;
import org.eclipse.swt.widgets.TreeItem;
import org.eclipse.swt.widgets.Widget;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.IEditorReference;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.IWorkbenchPartSite;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.actions.ActionFactory;
import org.eclipse.ui.handlers.IHandlerService;
import org.eclipse.ui.internal.ActionSetManager;
import org.eclipse.ui.internal.IActionSetContributionItem;
import org.eclipse.ui.internal.KeyBindingService;
import org.eclipse.ui.internal.WorkbenchHandlerServiceHandler;
import org.eclipse.ui.internal.dnd.SwtUtil;
import org.eclipse.ui.internal.menus.ActionSet;
import org.eclipse.ui.internal.menus.WorkbenchMenuService;
import org.eclipse.ui.internal.registry.IActionSet;
import org.eclipse.ui.internal.services.ActionSetSourceProvider;
import org.eclipse.ui.keys.IBindingService;
import org.eclipse.ui.swt.IFocusService;
import org.eclipse.ui.wizards.IWizardCategory;
import org.eclipse.ui.wizards.IWizardDescriptor;
import org.eclipse.ui.ide.IDE;

import com.eclipse.listener.scenario.Scenario;
import com.eclipse.listener.scenario.task.Task;
import com.sun.corba.se.impl.javax.rmi.CORBA.Util;

public class Methods {
	//Variables.
	public static DateFormat dateFormat = new SimpleDateFormat("dd/MM/yyyy HH:mm:ss");	// used for finding current time.
	public static Date date = new Date();												// used for finding current time.

	
	/**
	 * Method for getting current time. 
	 * Returns a string that will look like: "28/07/2014 12:50:10"
	 * @return string
	 */
	public static String getCurrentTime(){
		String time = dateFormat.format(date = new Date());
		return time;
	}
	
	/**
	 * Method for returning the number of selected TreeItems of a Tree.
	 * @param Tree
	 * @return Int
	 */
	public static int getSelectedTreeItemsCount(Tree tree){
		int itemsCount = 0;
		if(tree != null){
			itemsCount = tree.getSelectionCount();
		}
		System.out.println("\n[Methods.java] Selected TreeItem Count: " + itemsCount); //debug
		return itemsCount;
	}
	
	/**
	 * Method for returning the selected TreeItem of a Tree, or null if there is not a selected TreeItem.
	 * @param Tree
	 * @return TreeItem or null
	 */
	public static TreeItem getSelectedTreeItem(Tree tree){
		TreeItem resultTreeItem = null;
		
		//Get selected item if there is a Tree and it has a selected item.
		if(tree != null){
			if(getSelectedTreeItemsCount(tree) > 0){
				resultTreeItem = tree.getSelection()[0];
				System.out.println("\n[Methods.java] Selected TreeItem: " + resultTreeItem); //debug
			}			
		}		
		return resultTreeItem;
	}
	
	/**
	 * Method for returning the collection of selected TreeItems, or null if there is not selected any TreeItems.
	 * @param Tree
	 * @return TreeItem[] or null
	 */
	public static TreeItem[] getSelectedTreeItems(Tree tree){
		TreeItem[] resultTreeItems = null;
		
		//Get selected item if there is a Tree and it has a selected items.
		if(tree != null){
			if(getSelectedTreeItemsCount(tree) > 0){
				resultTreeItems = tree.getSelection();
				for (int i = 0; i < resultTreeItems.length; i++) {
					System.out.println("\n[Methods.java] TreeItem["+i+"]: " + resultTreeItems[i]); //debug
				}
			}
		}
		return resultTreeItems;
	}
	
	/**
	 * Method for returning the topmost parent-TreeItem of a selected child-TreeItem, or null if the selected TreeItem has no parents.
	 * @param Tree
	 * @return TreeItem or null. Ex: TreeItem {MyFirstProject}, when TreeItem {MyFirstClass.java} is selected.
	 */
	public static TreeItem getRootOfSelectedTreeItem(Tree tree){
		TreeItem parent = null;
		if(getSelectedTreeItem(tree) != null){
			parent = getSelectedTreeItem(tree);
			// Iterating recursively up in the Tree and returning the topmost TreeItem-parent.
			while( parent.getParentItem() != null ){
				parent = parent.getParentItem();
				System.out.println("\n[Methods.java] Parent: " + parent); //debug
			}			
		}
		return parent;
	}
	
	/**
	 * Method for returning the roots of the Tree, which is an array of TreeItems.
	 * @param Tree
	 * @return TreeItem[], which is the roots of the Tree.
	 */
	public static TreeItem[] getRootTreeItemsOfSelectedTree(Tree tree){
		TreeItem[] rootTreeItems = null;
		if(tree != null && tree.getItems().length > 0){
			rootTreeItems = tree.getItems();
		}
		//Debugging.
		if(rootTreeItems != null){
			for (int i = 0; i < rootTreeItems.length; i++) {
				System.out.println("\n[Methods.java] RootTreeItems["+i+"]: " + rootTreeItems[i]); //debug
			}
		}
		return rootTreeItems;
	}//end getRootTreeItemsOfSelectedTree.	
	
	/**
	 * Method for getting the name/label of the current active perspective of the workbench. 
	 * @return Ex: "Java", "Debug".
	 */
	public static String getCurrentPerspectiveName(){
		return PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().getPerspective().getLabel();
	}
	
	/**
	 * Method for getting the name/label of the currently selected view. 
	 * @return Ex: "MouseEventListenerView", "Console", "Car.java", "Package Explorer".
	 */
	public static String getCurrentlySelectedViewName(){		
		//Get title of the selected(opened) view in Eclipse workbench. Ex: 
		//String workbench1 = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().getActivePartReference().getTitle();		//Ex: MouseEventListenerView
		String name = "";
		if( PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().getActivePartReference().getPartName() != null){
			name = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().getActivePartReference().getPartName();	//Ex: MouseEventListenerView
		}		
		//String workbench3 = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().getActivePartReference().getPage().getLabel();	//Ex: Workspace
		//appendText("Currently Selected ViewID: " +id+ "\nTitle: " +workbench1+ "\nPartName: " +workbench2+ "\nPageLabel: " +workbench3);		
		return name;
	}
	
	/**
	 * Method for getting the ID of the currently selected view.
	 * @return Ex: "org.eclipse.ui.console.ConsoleView", "com.eclipse.listener.views.MouseEventListenerView"
	 */
	public static String getCurrentlySelectedViewID(){
		//Get view ID of currently selected(opened) view in Eclipse workbench. 
		return PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().getActivePartReference().getId(); 
	}
	
	/**
	 * Method for getting the name of the currently opened dialog window in eclipse.
	 * @return Ex: "Preferences", "New", "Open Perspective", "New Java Class", "Java - Eclipse Platform", "Properties for Car.java".
	 * "Import", "Export", "Runnable JAR File Export", "Install".
	 */
	public static String getCurrentlyOpenedDialogWindowName(){
		String name = "";
		try {
			Shell active = PlatformUI.getWorkbench().getDisplay().getActiveShell();		
			name = active.getText();			
		} catch (Exception e) {
			e.printStackTrace();
			System.out.println(e);
		}
		return name;
	}
	
	/**
	 * Method for returning the currently opened dialog window in Eclipse, or null if there is no active dialog window.
	 * @return Shell - returns the active shell, or null. This could be the shell for ex. "Preferences" or "New Java Project"-wizard.
	 */
	public static Shell getCurrentlyOpenedDialogWindow(){
		Shell active = null;
		try {
			active = PlatformUI.getWorkbench().getDisplay().getActiveShell();
		} catch (Exception e) {
			e.printStackTrace();
		}
		return active;
	}
	
	/**
	 * Method for opening a view or setting focus to the view given by a parameter.
	 * Ex: PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().showView("org.eclipse.ui.console.ConsoleView");
	 * @id org.eclipse.ui.console.ConsoleView - ID for the Console-view.
	 */
	public static void openView(String id){
		// Setter fokus til view'et gitt ved parameter, hvis det ikke allerede er lagt til vil koden gjre dette og deretter sette fokus til view'et.
		try {
			PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().showView(id);
			System.out.println("\nProgrammatically openView( " +id+ " )"); 
		} catch (Exception e) {
			e.printStackTrace();
			System.out.println("\n\n"+Methods.getCurrentTime()+", Open View Exception: " + e);
		}
	}
	
	/**
	 * Method for opening a new-wizard dialog window given by a paramter.
	 * Ex: "New Java Class", "New Java Project", "New Java Package"
	 * @id org.eclipse.jdt.ui.wizards.JavaProjectWizard - New Java Project
	 */
	public static void openNewWizardDialogWindow(String id){
		try {
			System.out.println("\nOpening Wizard Dialog, id: " +id);
			// Iterere gjennom alle new-wizards for  se om gitt id finnes der.
			IWizardDescriptor descriptor = PlatformUI.getWorkbench().getNewWizardRegistry().findWizard(id);
			if(descriptor == null){
				descriptor = PlatformUI.getWorkbench().getNewWizardRegistry().getRootCategory().findWizard(id);
				if(descriptor == null){
					IWizardCategory rootCategory = PlatformUI.getWorkbench().getNewWizardRegistry().getRootCategory();
					IWizardCategory[] rootCategories = rootCategory.getCategories();
					for(int i = 0; i < rootCategories.length; i++) {
						descriptor = rootCategories[i].findWizard(id);
						if(descriptor != null){
							break;
						}
					}
					if(descriptor == null){
						IWizardDescriptor[] primaryDescriptors = PlatformUI.getWorkbench().getNewWizardRegistry().getPrimaryWizards();
						for (int i = 0; i < primaryDescriptors.length; i++) {
							if(primaryDescriptors[i].getId().equals(id)){
								descriptor = primaryDescriptors[i];
							}
							
							if(descriptor != null){
								break;
							}
						}
					}
				}
			}
			IWizard wizard = descriptor.createWizard();
			WizardDialog wd = new WizardDialog(PlatformUI.getWorkbench().getDisplay().getActiveShell(), wizard);
			String title = wizard.getWindowTitle();
			wd.setTitle(title);
			wd.open();			
		} catch (Exception e) {
			e.printStackTrace();
			System.out.println("\n\n"+Methods.getCurrentTime()+", Open New Wizard Dialog Window Exception: " + e);
		}
	}//openNewWizard
	
	/**
	 * Generic method for checking if an Object is null.
	 * @param object
	 * @return <b>boolean</b> true if the object is null, and false if the object is not null.
	 */
	public static boolean isObjectNull(Object object){
		boolean result = true;
		if( object != null ){
			result = false;
		}
		return result;
	}
	
	/**
	 * Method for executing a command given by a parameter.
	 * Uses the IHandlerService to execute a command.
	 * @param command, Ex: "org.eclipse.ui.newWizard" - open the "New" wizard selection window.
	 */
	public static void executeCommand(String command){
		//Execute a command.
		IWorkbenchPartSite site = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().getActivePart().getSite();
		IHandlerService service = (IHandlerService) site.getService(IHandlerService.class);
		System.out.println("\n"+Methods.getCurrentTime()+", IHandlerService service: " + service);
		try {
			if( command != null ){
				service.executeCommand(command, null);
				System.out.println("\n"+Methods.getCurrentTime()+"[Methods]: Executing command: " + command);
			}			
		} catch (ExecutionException e) {
			System.out.println("\nExecutionException: " + e);
			e.printStackTrace();
		} catch (NotDefinedException e) {
			System.out.println("\nNotDefinedException: " + e);
			e.printStackTrace();
		} catch (NotEnabledException e) {
			System.out.println("\nNotEnabledException: " + e);
			e.printStackTrace();
		} catch (NotHandledException e) {
			System.out.println("\nNotHandledException: " + e);
			e.printStackTrace();
		}
		
	}//executeCommand.	
	
	/**
	 * Method for getting the outmost Composite for a Shell-object.
	 */
	public static Composite getCompositeOfShell(Shell shell){
		System.out.println("\n[Methods.java]: getCompositeOfShell()");
		Composite composite = null;
		//Shell cannot be null.
		if( shell != null ){
			System.out.println("Shell text: " + shell.getText());
			Control[] shellChildren = shell.getChildren();
			//Shell must have Control-objects.
			if( shellChildren != null ){
				System.out.println("shellChildren length: " + shellChildren.length);
				//Iterate through Control-objects inside the Shell.
				for(int i = 0; i < shellChildren.length; i++) {
					System.out.println(i+") shellChildren: " +shellChildren[i]);
					if( shellChildren[i] instanceof Composite ){
						composite = (Composite)shellChildren[i];
						System.out.println(shellChildren[i] + "is instanceof Composite");
						return composite;
					}
				}
			}
		}
		return composite;
	}//end getCompositeOfShell().	
	
	/**
	 * Method for copying a String to the OS clipboard.
	 */
	public static void copyToClipboard(String string){
		if( string != null && !string.isEmpty() ){
			Toolkit toolkit = Toolkit.getDefaultToolkit();
			Clipboard clipboard = toolkit.getSystemClipboard();
			StringSelection strSel = new StringSelection(string);
			clipboard.setContents(strSel, null);
			System.out.println("[Methods]: copyToClipboard: " + string);
		}		
	}//end copyToClipboard.
	
	/**
	 * Method for simulating a mouse click by posting SWT-events(MouseDown, MouseUp) to the Display-object.
	 */
	public static void simulateMouseClick(){
		System.out.println("[Methods]: simulateMouseClick");
		Event event = new Event();
		threadSleep(200);
	    //Simulate MouseDown-Event.
		event.type = SWT.MouseDown;
	    event.button = 1;
	    getDisplay().post(event);
	    threadSleep(200);
	    //Simulate MouseUp-Event.
	    event.type = SWT.MouseUp;
		getDisplay().post(event);

//	GAMMEL AWT ROBOT KODE!!!			
//		try {
//			Robot bot = new Robot();
//			bot.setAutoDelay(40);
//			bot.setAutoWaitForIdle(true);									
//			bot.delay(100);
//			bot.mousePress(KeyEvent.BUTTON1_DOWN_MASK);
//			bot.mouseRelease(KeyEvent.BUTTON1_DOWN_MASK);
//			bot.delay(200);
//			bot = null;
//		} catch (Exception e) {
//			System.out.println("Robot Exception mouse click:" + e); 
//			e.printStackTrace();
//		}//try-catch.
		
	}//simulateMouseClick.
	
	/**
	 * Method for simulating a mouse right-click by posting SWT-events(MouseDown, MouseUp) to the Display-object.
	 */
	public static void simulateMouseRightClick(){
		System.out.println("[Methods]: simulateMouseRightClick");
		Event event = new Event();
		threadSleep(200);
	    //Simulate MouseDown-Event.
		event.type = SWT.MouseDown;
	    event.button = 3;
	    getDisplay().post(event);
	    threadSleep(200);
	    //Simulate MouseUp-Event.
	    event.type = SWT.MouseUp;
		getDisplay().post(event);		
	}//simulateMouseRightClick.

	
	/**
	 * Method for simulating a keyboard keypress by posting SWT-events(KeyDown, KeyUp) to the Display-object.
	 * <br><br><b>NB!</b> For simulating letters(a-/A-), digits(0,1,2...) or symbols(!"#%...),
	 * <br>use character convention: <i><b>simulateKeyboardKeyPress( (int)char );</b></i>
	 * <br>Ex: <i>simulateKeyboardKeyPress( (int)'f' );</i>
	 * <br>Ex: <i>simulateKeyboardKeyPress( (int)'0' );</i>
	 * <br>Ex: <i>simulateKeyboardKeyPress( (int)'!' );</i>    
	 * @param swtKey - Ex: SWT.ARROW_DOWN, SWT.ALT.
	 */
	public static void simulateKeyboardKeyPress(int swtKey){
		boolean parameterIsCharacter = false;
		if( (swtKey >= 32 && swtKey <= 126)  || swtKey==230 || swtKey==248 || swtKey==229 || swtKey==198 || swtKey==216 || swtKey==197 ){  //see ASCII-table.
			parameterIsCharacter = true;
		}
		System.out.println("[Methods]: simulateKeyboardKeyPress: " + swtKey);
		Event event = new Event();
		threadSleep(100);
	    //Simulate KeyDown-Event.
		event.type = SWT.KeyDown;
		if( parameterIsCharacter ){
			event.character = (char)swtKey;
		}else{
			event.keyCode = swtKey;
		}
        
	    getDisplay().post(event);	    
	    threadSleep(100);
	    //Simulate KeyUp-Event.
	    event.type = SWT.KeyUp;
	    if( parameterIsCharacter ){
			event.character = (char)swtKey;
		}else{
			event.keyCode = swtKey;
		}
	    getDisplay().post(event);
	}//end simulateKeyboardKeyPress.
	
	/**
	 * Method for simulating a keyboard keydown by posting SWT-event(KeyDown) to the Display-object.
	 * <br><br><b>NB!</b> For simulating letters(a-/A-), digits(0,1,2...) or symbols(!"#%...),
	 * <br>use character convention: <i><b>simulateKeyboardKeyDown( (int)char );</b></i>
	 * <br>Ex: <i>simulateKeyboardKeyDown( (int)'f' );</i>
	 * <br>Ex: <i>simulateKeyboardKeyDown( (int)'0' );</i>
	 * <br>Ex: <i>simulateKeyboardKeyDown( (int)'!' );</i>    
	 * @param swtKey - Ex: SWT.ARROW_DOWN, SWT.ALT.
	 */
	public static void simulateKeyboardKeyDown(int swtKey){
		boolean parameterIsCharacter = false;
		if( (swtKey >= 32 && swtKey <= 126)  || swtKey==230 || swtKey==248 || swtKey==229 || swtKey==198 || swtKey==216 || swtKey==197 ){  //see ASCII-table.
			parameterIsCharacter = true;
		}
		System.out.println("[Methods]: simulateKeyboardKeyDown: " + swtKey);
		Event event = new Event();
		threadSleep(100);
	    //Simulate KeyDown-Event.
		event.type = SWT.KeyDown;
		if( parameterIsCharacter ){
			event.character = (char)swtKey;
		}else{
			event.keyCode = swtKey;
		}        
	    getDisplay().post(event);		    
	}//simulateKeyboardKeyDown.
	
	/**
	 * Method for simulating a keyboard keyup by posting SWT-event(KeyUp) to the Display-object.
	 * <br><br><b>NB!</b> For simulating letters(a-/A-), digits(0,1,2...) or symbols(!"#%...),
	 * <br>use character convention: <i><b>simulateKeyboardKeyUp( (int)char );</b></i>
	 * <br>Ex: <i>simulateKeyboardKeyUp( (int)'f' );</i>
	 * <br>Ex: <i>simulateKeyboardKeyUp( (int)'0' );</i>
	 * <br>Ex: <i>simulateKeyboardKeyUp( (int)'!' );</i>    
	 * @param swtKey - Ex: SWT.ARROW_DOWN, SWT.ALT.
	 */
	public static void simulateKeyboardKeyUp(int swtKey){
		boolean parameterIsCharacter = false;
		if( (swtKey >= 32 && swtKey <= 126)  || swtKey==230 || swtKey==248 || swtKey==229 || swtKey==198 || swtKey==216 || swtKey==197 ){  //see ASCII-table.
			parameterIsCharacter = true;
		}
		System.out.println("[Methods]: simulateKeyboardKeyUp: " + swtKey);
		Event event = new Event();
		threadSleep(100);
	    //Simulate KeyUp-Event.
	    event.type = SWT.KeyUp;
	    if( parameterIsCharacter ){
			event.character = (char)swtKey;
		}else{
			event.keyCode = swtKey;
		}
	    getDisplay().post(event);		
	}//simulateKeyboardKeyUp.
	
		
	/**
	 * Method that iterates through a given Collection of Scenario-objects, and finds the index of a given Scenario.
	 * @param scenarios
	 * @param scenario
	 * @return integer: index or -1 if not found.
	 */
	public static int findScenarioIndex(Collection<Scenario> scenarios, Scenario scenario){
		//Avoid nullpointer exception.
		if( scenarios == null || scenario == null ){
			return -1;
		}
		int index = 0;
		for(Scenario sc : scenarios) {
			if( sc.getTitle().equals(scenario.getTitle()) ){
				return index;
			}
			index++;
		}
		return -1;
	}//end findScenarioIndex.
	
	/**
	 * Method that iterates through a given Collection of Task-objects, and finds the index of a given Task.
	 * @param tasks
	 * @param task
	 * @return integer: index or -1 if not found.
	 */
	public static int findTaskIndex(Collection<Task> tasks, Task task){
		//Avoid nullpointer exception.
		if( tasks == null || task == null ){
			return -1;
		}
		int index = 0;
		for(Task t : tasks) {
			if( t.getTitle().equals(task.getTitle()) ){
				return index;
			}
			index++;
		}
		return -1;
	}//end findTaskIndex.
	
	/**
	 * Method for programmatically executing Scenario 1 Task 1: Open the "New"-dialog window in the main-toolbar.
	 */
	public static void Scenario1Task1(){
		System.out.println("Scenario1Task1 !");
		executeCommand("org.eclipse.ui.newWizard");		
	}//end Scenario1Task1.
	
	/**
	 * Method for programmatically executing Scenario 1 Task 2: Selecting the "Java Project" in the "New"-dialog window.
	 */
	public static void Scenario1Task2(){
		System.out.println("Scenario1Task1 !");
		String str = "";
		if( Methods.getCurrentlyOpenedDialogWindow() != null ){
			str = Methods.getCurrentlyOpenedDialogWindow().getText();
		}
		System.out.println("executeScenario1Task2: Curently opened dialog window: " + str);
		
		//"New"-shell window er pent og aktivt.
		if( Methods.getCurrentlyOpenedDialogWindow() != null && Methods.getCurrentlyOpenedDialogWindow().getText().equals("New") ){
			System.out.println("Methods.getCurrentlyOpenedDialogWindow()!=null: " +Methods.getCurrentlyOpenedDialogWindow().getText() );
			//Bruke ShellObjectIterator til  hente ut alle Control-objects fra "New"-dialog window Shell.
			ShellObjectIterator shellObjectIterator = new ShellObjectIterator( Methods.getCurrentlyOpenedDialogWindow() );
			ArrayList<Control> shellControls = shellObjectIterator.getControls();
			if( shellControls != null ){
				System.out.println("[ScenarioHandler]: ArrayList<Control> shellControls, size: " + shellControls.size());
				for (Control control : shellControls) {
					System.out.println("[ScenarioHandler]: control: " +control);
					//Finne Tree-object i New-dialog window.
					if( control instanceof Tree ){
						System.out.println("[ScenarioHandler]: control: " +control+ " is an instance of Tree!");
						final Tree tree = (Tree)control;
						TreeItem[] treeItems = tree.getItems();
						if( treeItems != null && treeItems.length > 0 ){
							for (int j = 0; j < treeItems.length; j++) {
								System.out.println("treeItems["+j+"]: "+ treeItems[j].getText()+ ", Shell: " +treeItems[j].getParent().getShell().getText() );
								if( treeItems[j].getText().equals("Java Project") ){//Java Project
									System.out.println("TreeItem: " +treeItems[j].getText()+ ", blir automatisk selected!");
									final TreeItem treeItem = treeItems[j];				
									//New thread - OPPDATERING: man m tydligvis bruke multithreading til  oppdatere GUI, s dette er mten  gjre det p!
									tree.getShell().getDisplay().asyncExec (new Runnable () {
										public void run () {
											if(!tree.getShell().isDisposed()){
												System.out.println("Scenario 1 Task 2: Selecting TreeItem: "+ treeItem.getText() + " in a new thread.");
												tree.setSelection( treeItem ); //Denne alene setter markeringa til elementet, men label under select a wizard endres ikke.
												Event event = new Event();
												event.widget = tree;
												tree.notifyListeners(SWT.Selection, event);//Nr denne var med ble label under select a wizard endret til valgt treeItem.
											}
										}
								   });//new thread.
								}
							}//for.
						}			
					}//Tree.
				}//foreach.
			}			
		}//end New.		
		System.out.println("[ScenarioHandler]: executeScenario1Task2() finished !");	
	}//end Scenario1Task2.
	
	/**
	 * Method for getting the Display for this Workbench.
	 * @return Display.
	 */
	public static Display getDisplay(){
		return PlatformUI.getWorkbench().getDisplay();
	}
	
	/**
	 * Convenience method for removing any mnemonics from the given string. For example, removeMnemonics("&Open") will return "open".
	 * @return string: the text sans mnemonics
	 */
	public static String removeMnemonics(String string){
		String result = org.eclipse.jface.action.Action.removeMnemonics( string );
		result = result.replace("...", "");
		return result.toLowerCase();
	}
	
	/**
	 * Method for sleeping the Thread for a given milli-seconds. Calls the Thread.sleep(long arg) method.
	 * @param milliSeconds
	 */
	public static void threadSleep(long milliSeconds){
		try {
			Thread.sleep(milliSeconds);
		} catch (InterruptedException e) {
			e.printStackTrace();
			System.out.println("[Methods]: threadSleep-Error: " + e);
		}
	}
	
	/**
	 * Method for returning the active part in the workbench.
	 * <br><br><i>PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().getActivePart();</i><br>
	 * @return IWorkbenchPart
	 */
	public static IWorkbenchPart getActivePart(){
		return PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().getActivePart();
	}
	
	/**
	 * Method for returning the active page in the workbench.
	 * <br><br><i>PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage();</i><br>
	 * @return IWorkbenchPage
	 */
	public static IWorkbenchPage getActivePage() {
		return PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage();
	}
	
	/**
	 * Method for iterating through the opened editors and giving focus to any Java Editor.
	 * @return true if there is a opened Java Editor, false otherwise.
	 */
	public static boolean openActiveJavaEditor(){
		boolean foundAJavaEditor = false;
		//Get the active page for the workbench.
		IWorkbenchPage iworkbenchpage = Methods.getActivePage();
		if(iworkbenchpage != null){
			String editorTitle = "";
			if(iworkbenchpage.getActiveEditor().getTitle() != null){
				editorTitle = iworkbenchpage.getActiveEditor().getTitle();
			}
			System.out.println("iworkbenchpage getActiveEditor title: " +iworkbenchpage.getActiveEditor().getTitle() );
			try {
				//If the opened and active editor is an editor for a java file, then set focus to it.
				if( WorkspaceMethods.isAJavaFile( editorTitle ) ){
					iworkbenchpage.getActiveEditor().setFocus();
					foundAJavaEditor = true; //Update that we found a java editor.
					return true;
				}else{
					//
					IEditorReference[] editors = iworkbenchpage.getEditorReferences();
					if(editors != null){
						for (int i = 0; i < editors.length; i++) {
							System.out.println("\neditors: " + editors[i]+ ", title: " +editors[i].getTitle());
							//Check if the opened editor is an editor for a java file.
							if( WorkspaceMethods.isAJavaFile( editors[i].getTitle() ) ){
								IEditorPart ieditorpart = editors[i].getEditor(true);								
								if(ieditorpart != null){
									iworkbenchpage.activate(ieditorpart);
									System.out.println(editors[i].getTitle() + ", is an editor for a java file");
									foundAJavaEditor = true; //Update that we found a java editor.
									return true;
								}
							}
						}
					}
				}//else.
				
				//Error message to the user if there were not any opened java editors.
				if( !foundAJavaEditor ){
					MessageDialog.openError(null, "Error", "There are currently not opened any java file. Please open a java file!");
				}				
			} catch (Exception e) {
				System.out.println("[Methods] exception: " + e);
			}			
		}
		return false;
	}//end openActiveJavaEditor.
	
	/**
	 * Method for returning the IBindingService
	 * @return
	 */
	public static IBindingService getIBindingService(){
		IBindingService service = (IBindingService) PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().getActivePart().getSite().getService(IBindingService.class);
      	return service;
	}
	
	/**
	 * Method for setting focus to a button in the Eclipse Main Menu Bar.
	 * <br>This is the same as pressing the "ALT"-keyboard button in Microsoft Windows followed by a mnemonics button.
	 * @param menuBarButton - String. Ex:  file, edit, source, refactor, navigate, search, project, run, window, help.
	 */
	public static void setFocusToMainMenuBar(String menuBarButton){
		//The keyboard click "F10" or "Alt" should set focus and highlight the File-menuitem. The ALT or F10 only works on windows OS!
		
		//This uses the mnemonics to open a menu on the main menu bar -> pressing the Alt-button on the keyboard followed by a letter.
		if( menuBarButton.equals("file") ){
			simulateKeyboardKeyPress( SWT.ALT );
			simulateKeyboardKeyPress( (int)'f' );
		}
		else if( menuBarButton.equals("edit") ){
			simulateKeyboardKeyPress( SWT.ALT );
			simulateKeyboardKeyPress( (int)'e' );
		}
		else if( menuBarButton.equals("source") ){
			simulateKeyboardKeyPress( SWT.ALT );
			simulateKeyboardKeyPress( (int)'s' );
		}
		else if( menuBarButton.equals("refactor") ){
			simulateKeyboardKeyPress( SWT.ALT );
			simulateKeyboardKeyPress( (int)'t' );
		}
		else if( menuBarButton.equals("navigate") ){
			simulateKeyboardKeyPress( SWT.ALT );
			simulateKeyboardKeyPress( (int)'n' );
		}
		else if( menuBarButton.equals("search") ){
			simulateKeyboardKeyPress( SWT.ALT );
			simulateKeyboardKeyPress( (int)'a' );
		}
		else if( menuBarButton.equals("project") ){
			simulateKeyboardKeyPress( SWT.ALT );
			simulateKeyboardKeyPress( (int)'p' );
		}
		else if( menuBarButton.equals("run") ){
			simulateKeyboardKeyPress( SWT.ALT );
			simulateKeyboardKeyPress( (int)'r' );
		}
		else if( menuBarButton.equals("window") ){
			simulateKeyboardKeyPress( SWT.ALT );
			simulateKeyboardKeyPress( (int)'w' );
		}
		else if( menuBarButton.equals("help") ){
			simulateKeyboardKeyPress( SWT.ALT );
			simulateKeyboardKeyPress( (int)'h' );
		}
	}//end setFocusToMainMenuBar.

	public static void simulateKeyboardShiftPlusF10() {
		//Shift-key down		
		getDisplay().syncExec(new Runnable() {
			public void run() {
				Methods.threadSleep(200);			
				Event event = new Event();
				event.type = SWT.KeyDown;
				event.keyCode = SWT.SHIFT;
				getDisplay().post(event);
				System.out.println("Simulate Shift Down");
			}
		});	
		//F10-key press	
		getDisplay().syncExec(new Runnable() {
			public void run() {
				Event event = new Event();
				event.type = SWT.KeyDown;
				event.keyCode = SWT.F10;
				getDisplay().post(event);
				System.out.println("Simulate F10 Down");
				try {
					Thread.sleep(10);
				} catch (InterruptedException e) {
				}
				event.type = SWT.KeyUp;
				getDisplay().post(event);
				System.out.println("Simulate F10 Up");
				try {
					Thread.sleep(100);
				} catch (InterruptedException e) {
				}		
			}
		});	
		//Shift-key up.		
		getDisplay().syncExec(new Runnable() {
			public void run() {
				Event event = new Event();
				event = new Event();
				event.type = SWT.KeyUp;
				event.keyCode = SWT.SHIFT;
				getDisplay().post(event);
				System.out.println("Simulate Shift Up");
			}
		});
	}//simulateKeyboardShiftPlusF10.
	
	/**
	 * Method that opens the given file in an editor.
	 * @param page IWorkbenchPage
	 * @param input IFile
	 */
	public static void openFileInEditor(IWorkbenchPage page, IFile input){
		try {
			IDE.openEditor(page, input);
		} catch (PartInitException e) {
			e.printStackTrace();
			System.out.println("Error openFileInEditor: page: " + page.getLabel() + ", ifile: " + input.getName());
		}
	}//end openFileInEditor.
	
	/**
	 * Method for finding and returning a specific ToolItem from the main view of Eclipse. Ex: "New", "Run", "New Java Class".
	 * @param toolItem String, or null otherwise.
	 */
	public static ToolItem findToolItemInEclipseMainView(String toolItem){
		ShellObjectIterator eclipseMainViewControls = new ShellObjectIterator(Methods.getCurrentlyOpenedDialogWindow());
		if( eclipseMainViewControls != null ){
			for(Control control : eclipseMainViewControls.getControls()) {
				if( control instanceof ToolBar ){
					ToolBar toolbar = (ToolBar)control;
					if( toolbar.getItemCount() > 0 ){
						for (ToolItem item : toolbar.getItems()) {
							String toolText ="", toolTipText ="";
							if( item.getText() != null ){
								toolText = item.getText();
							}
							if( item.getToolTipText() != null ){
								toolTipText = item.getToolTipText();
							}								
							System.out.println("Toolitem: " + item+ ", text: "+toolText+", tooltip: " + toolTipText);							
							if( toolTipText.toLowerCase().equals(toolItem) || toolText.toLowerCase().equals(toolItem) ){
								System.out.println(toolTipText+" OR "+toolText+" == "+toolItem);
								return item;							    
							}//toolItem string.							
						}//foreach.
					}						
				}
			}//foreach.				
		}
		return null;
	}//end findToolItemInEclipseMainView.	
	
	/**
	 * Method that calculates the true screen coordination of a ToolItem. 
	 * <br>This method uses the parent ToolBar's toDisplay(0,0) to get the correct (X,Y)-coordination of the ToolBar.
	 * <br>Uses the ToolItem's getBounds to calculate the (X,Y)-coordinate.
	 */
	public static Point getCoordinatesOfToolItem(ToolItem toolItem){
		if( toolItem == null ){
			return null;
		}
		if( toolItem.getParent() == null ){
			return null;
 		}
		Point point = new Point(toolItem.getParent().toDisplay(0, 0).x, toolItem.getParent().toDisplay(0, 0).y);
		point.x = point.x + (toolItem.getBounds().x) + ((int)(toolItem.getBounds().width / 3));
		point.y = point.y + ((int)(toolItem.getBounds().height / 2));
		return point;
	}//end getCoordinatesOfToolItem.
	
	/**
	 * Method that calculates the true screen coordination of a TreeItem. 
	 * <br>This method uses the parent Tree's toDisplay(0,0) to get the correct (X,Y)-coordination of the TreeItem.
	 * <br>Uses the TreeItem's getBounds to calculate the (X,Y)-coordinate.
	 */
	public static Point getCoordinatesOfTreeItem(TreeItem treeItem){
		if( treeItem == null ){
			return null;
		}
		if( treeItem.getParent() == null ){
			return null;
 		}
		//getBounds: (rect.left, rect.top, width, height).
		Point point = new Point(treeItem.getParent().toDisplay(0, 0).x, treeItem.getParent().toDisplay(0, 0).y);
		point.x = point.x + (treeItem.getBounds().x) + ((int)(treeItem.getBounds().width / 3));
		point.y = point.y + (treeItem.getBounds().y) + ((int)(treeItem.getBounds().height / 2));
		return point;
	}//end getCoordinatesOfTreeItem.
	
	/**
	 * Method that calculates the true screen coordination of a Button. 
	 */
	public static Point getCoordinatesOfButton(Button button){
		if( button == null ){
			return null;
		}
		//getBounds: (rect.left, rect.top, width, height).
		Point point = new Point(button.toDisplay(0, 0).x, button.toDisplay(0, 0).y);
		point.x = point.x + ((int)(button.getBounds().width / 3));
		point.y = point.y + ((int)(button.getBounds().height / 2));
		return point;
	}//end getCoordinatesOfButton.
	
}//end Methods.java