package com.eclipse.listener.scenario;

import com.eclipse.listener.scenario.task.Task;

/**
 * Listening-Interface for the Observers(ScenarioView.java). 
 * When certain events occur, the Observable(Scenario.java) then iterates through the Observers firing the appropriate method. 
 */
public interface ScenarioProgressListener {	
	/**
	 * Method called when a Task is activated.
	 * @param task Task
	 */
	public void taskActivated(Task task);
	
	/**
	 * Method called when a Task is finished.
	 * @param task
	 */
	public void taskCompleted(Task task);
	
	/**
	 * Method called when a Scenario is finished.
	 * @param scenario Scenario
	 */
	public void scenarioCompleted(Scenario scenario);
	
}//end ScenarioProgressListener.