package com.eclipse.listener.scenario.task;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.MenuItem;

import com.eclipse.listener.scenario.task.autocomplete.AutoExecution;

public class ContextMenuItemClick extends SwtTask {
	
	/**
	 * Constructor
	 * @param menuItem
	 */
	public ContextMenuItemClick(String menuItem) {
		super(menuItem, SWT.Selection);
	}
	
	/**
	 * Constructor
	 * @param menuItem
	 * @param description
	 * @param autoExecuteTask
	 */
	public ContextMenuItemClick(String menuItem, String description, AutoExecution autoExecuteTask) {
		super(menuItem, description, SWT.Selection, autoExecuteTask);
	}	

	@Override
	protected boolean isTaskEvent(Event event) {
		//MenuItem - A MenuItem without a Menu. Ex: "&Preferences".
		if( event.widget instanceof MenuItem ){
			MenuItem menuItem = (MenuItem)event.widget;
			String menuItemText = "";
			if( menuItem!=null ){
				menuItemText = menuItem.getText();		//Ex: &Preferences.
			}
			System.out.println("menuItemText: "+menuItemText);
			//Check if the text of the clicked MenuItem equals the title of this Task.
			if( removeMnemonics(menuItemText).contains(getTitle().toLowerCase()) ){
				System.out.println("["+getClass().getSimpleName()+"]: Task completed! MenuItem clicked in the context menu: " + getTitle());
				//Finish the task: isFinished=true, isActivated=false, removeListeners().
				return true;
			}
		}//MenuItem.		
		
		return false;
	}//isTaskEvent.

}//ContextMenuItemClick.