package com.eclipse.listener.scenario.task;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Tree;
import org.eclipse.swt.widgets.TreeItem;

import com.eclipse.listener.helpClasses.Methods;
import com.eclipse.listener.helpClasses.WorkspaceMethods;
import com.eclipse.listener.scenario.task.autocomplete.AutoExecution;

public class OpenJavaProjectContextMenu extends SwtTask {
	
	public OpenJavaProjectContextMenu(String title){
		super(title, SWT.MenuDetect);
	}

	public OpenJavaProjectContextMenu(String title, String description, AutoExecution autoExecuteTask) {
		super(title, description, SWT.MenuDetect, autoExecuteTask);
	}

	@Override
	protected boolean isTaskEvent(Event event) {
		if( event.widget instanceof Tree ){
			Tree tree = (Tree)event.widget;
			if( tree != null && tree.getItemCount() > 0 ){
				System.out.println("MenuDetect Event Tree: " + tree + ", count: " + tree.getItemCount());
				if( Methods.getSelectedTreeItem(tree) != null ){
					TreeItem selectedItem = Methods.getSelectedTreeItem(tree);
					try {
						if( WorkspaceMethods.isAJavaProject(selectedItem.getText()) ){
							System.out.println(selectedItem.getText() + ", is a java project!");
							return true;
						}
					} catch (CoreException e) {
						e.printStackTrace();
					}
				}			
			}
		}//Tree.
		return false;
	}

}//open context menu.