package com.eclipse.listener.scenario.task.autocomplete;

import java.util.ArrayList;

import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Shell;

import com.eclipse.listener.helpClasses.Methods;
import com.eclipse.listener.helpClasses.ShellObjectIterator;

public class ClickDialogButtonInNewWizardExecution extends AutoExecution {

	public ClickDialogButtonInNewWizardExecution(String dialogButton) {
		super(dialogButton);
	}

	@Override
	public void execute() {
		//Next.
		if( getTitle().toLowerCase().equals("next") ){		
			//Execute New-wizard, and select treeitem.					
			SelectTreeItemInNewWizardExecution newWizardClick = new SelectTreeItemInNewWizardExecution("Java Project");
			newWizardClick.execute();					
			
			//Execute dialog button click.
			Methods.getDisplay().asyncExec(new Runnable() {
				public void run() {
					clickDialogButton("&Next >");		//&Finish, Cancel.
				}
			});		
		}//end next.
		
		//Finish.
		else if( getTitle().toLowerCase().equals("finish") ){			
			//Execute new-wizard, select java project, click next.
			ClickDialogButtonInNewWizardExecution newJavaProjectNextClick = new ClickDialogButtonInNewWizardExecution("Next");
			newJavaProjectNextClick.execute();
						
			//Execute dialog button click.
			Methods.getDisplay().asyncExec(new Runnable() {
				public void run() {
					Methods.threadSleep(500);
					System.out.println("Opened dialog window: " + Methods.getCurrentlyOpenedDialogWindowName());			
					clickDialogButton("&Finish");		//&Finish, Cancel.				
				}
			});
		}//end finish.		
		
	}//end execute.

	/**
	 * Method for clicking the button with the given text. Ex: "&Next >", "&Finish".
	 * @param title String
	 */
	private void clickDialogButton(String title) {
		System.out.println("[ClickDialogButtonInNewWizardExecution]: clickDialogButton(), title: " + title);
		if( Methods.getCurrentlyOpenedDialogWindow() != null ){
			System.out.println("Methods.getCurrentlyOpenedDialogWindow()!=null: " +Methods.getCurrentlyOpenedDialogWindow().getText() );
			//Bruke ShellObjectIterator til  hente ut alle Control-objects fra "New Java Project"-dialog window Shell.
			ShellObjectIterator shellObjectIterator = new ShellObjectIterator( Methods.getCurrentlyOpenedDialogWindow() );
			ArrayList<Control> shellControls = shellObjectIterator.getControls();
			if( shellControls != null ){
				System.out.println("[ClickDialogButtonInNewWizardExecution]: ArrayList<Control> shellControls, size: " + shellControls.size());
				for(Control control : shellControls) {
					if( control instanceof Button ){ //Ex: Next-button.
						final Button button = (Button)control;
						if( button.getText() != null && button.getText().equals(title) ){
							System.out.println("[ClickDialogButtonInNewWizardExecution]: button: "+button.getText()+ ", title: " +title );
							Methods.getDisplay().asyncExec (new Runnable () {
								public void run () {
									System.out.println("[ClickDialogButtonInNewWizardExecution]: set focus and click enter.");
									Point point = Methods.getCoordinatesOfButton(button);
									System.out.println("BUTTON: " + button+", text: "+button.getText()+", bounds: "+button.getBounds()+", toDisplay: "+button.toDisplay(0, 0)+", point: "+point);
									Methods.getDisplay().setCursorLocation(point);
									Methods.threadSleep(500);
									if( button.isEnabled() ){
										Methods.simulateMouseClick();
									}else{
										MessageDialog.openWarning(null, "Warning", "Cannot click " + getTitle()+ " yet!");
									}
									
									
//									button.setFocus();
//									Methods.simulateKeyboardKeyPress(SWT.CR);
//									Event event = new Event();
//									event.widget = button;
//									button.notifyListeners(SWT.Selection, event);										
								}
							});//new thread.
						return;
						}
					}//Button.
				}//foreach.
			}			
		}//New.
		else{
			//DEBUGGING.
			System.out.println("[ClickDialogButtonInNewWizardExecution]: Methods.getCurrentlyOpenedDialogWindow() == null: "+(Methods.getCurrentlyOpenedDialogWindow() == null) );
			if( Methods.getCurrentlyOpenedDialogWindow() != null ){
				System.out.println("[ClickDialogButtonInNewWizardExecution]: Methods.getCurrentlyOpenedDialogWindow(): " + Methods.getCurrentlyOpenedDialogWindow().getText() );
			}
		}
	}//end clickDialogButton.

}//end ClickDialogButtonInNewWizardExecution.