package com.eclipse.listener.scenario.task.autocomplete;

import org.eclipse.swt.SWT;

import com.eclipse.listener.helpClasses.Methods;

public class EclipseCommandExecution extends AutoExecution {

	public EclipseCommandExecution(String title) {
		super(title);
	}

	@Override
	public void execute() {
		if( getTitle().toLowerCase().equals("package explorer") ){
			//Maximize Eclipse.
			Methods.getDisplay().getActiveShell().setMaximized(true);				
			Methods.threadSleep(300);
			Methods.openView("org.eclipse.jdt.ui.PackageExplorer");
		}//package explorer.
		else if( getTitle().toLowerCase().equals("content assist") ){
			//Open Active Java Editor.
			Methods.getDisplay().asyncExec(new Runnable() {
				public void run() {
					Methods.openActiveJavaEditor();				
				}
			});
			//Execute "Content Assist" command.
			Methods.getDisplay().asyncExec(new Runnable() {
				public void run() {
					Methods.threadSleep(150);
					Methods.executeCommand("org.eclipse.ui.edit.text.contentAssist.proposals");			
				}
			});				
		}//content assist.
		else if( getTitle().toLowerCase().equals("context menu java project") ){
			//Select a Java Project.
			Methods.getDisplay().syncExec(new Runnable() {
				public void run() {
					JavaProjectInPackageExplorerExecution selectAJavaProject = new JavaProjectInPackageExplorerExecution();
					selectAJavaProject.execute();		
				}
			});	
			
			//Simulate right-click button.
			Methods.getDisplay().syncExec(new Runnable() {
				public void run() {
					Methods.threadSleep(300);
					Methods.simulateMouseRightClick();
//					Methods.simulateKeyboardShiftPlusF10();				
				}
			});	
			
		}//context menu java project.
	}
	
}//end EclipseCommandExecution.