package com.eclipse.listener.scenario.task.autocomplete;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IProject;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.IEditorReference;
import org.eclipse.ui.IWorkbenchPage;

import com.eclipse.listener.helpClasses.Methods;
import com.eclipse.listener.helpClasses.WorkspaceMethods;

public class OpenAJavaFileExecution extends AutoExecution {

	public OpenAJavaFileExecution() {
		super("OpenAJavaFileExecution");
	}

	@Override
	public void execute() {
		//TODO: Itererer n gjennom pne editorer og setter fokus til den frste editoren som er av typen Java Editor.
		//TODO: Kan se p hvordan man pner en tilfeldig ".java"-fil fra workspace.
		
		boolean foundAJavaEditor = false;
		//Get the active page for the workbench.
		IWorkbenchPage iworkbenchpage = Methods.getActivePage();
		if(iworkbenchpage != null){
			String editorTitle = "";
			if(iworkbenchpage.getActiveEditor() != null && iworkbenchpage.getActiveEditor().getTitle() != null){
				editorTitle = iworkbenchpage.getActiveEditor().getTitle();
			}
			System.out.println("iworkbenchpage getActiveEditor title: " +editorTitle );
			try {
				//If the opened and active editor is an editor for a java file, then set focus to it.
				if( WorkspaceMethods.isAJavaFile( editorTitle ) ){
					iworkbenchpage.getActiveEditor().setFocus();
					foundAJavaEditor = true; //Update that we found a java editor.
				}else{
					//
					IEditorReference[] editors = iworkbenchpage.getEditorReferences();
					if(editors != null){
						for (int i = 0; i < editors.length; i++) {
							System.out.println("\neditors: " + editors[i]+ ", title: " +editors[i].getTitle());
							//Check if the opened editor is an editor for a java file.
							if( WorkspaceMethods.isAJavaFile( editors[i].getTitle() ) ){
								IEditorPart ieditorpart = editors[i].getEditor(true);								
								if(ieditorpart != null){
									iworkbenchpage.activate(ieditorpart);
									foundAJavaEditor = true; //Update that we found a java editor.
								}
								System.out.println(editors[i].getTitle() + ", is an editor for a java file");
								break;
							}
						}
					}
				}//else.
				
				//There is not opened any java editors.
				if( !foundAJavaEditor ){
					IFile arbitraryJavaFileFromWorkspace = WorkspaceMethods.getRandomJavaSourceFileFromWorkspace();
					if( arbitraryJavaFileFromWorkspace == null ){
						MessageDialog.openError(null, "Error", "There are currently not any Java File in the workspace!\n\nPlease create one.");
					}else{
						Methods.openFileInEditor(Methods.getActivePage(), arbitraryJavaFileFromWorkspace);
					}
				}
				
			} catch (Exception e) {
				System.out.println("[OpenAJavaFileExecution] exception: " + e);
			}			
		}		
		
	}//end execute.

}//end OpenAJavaFileExecution.