package com.eclipse.listener.scenario.task.autocomplete;

import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.SWT;

import com.eclipse.listener.helpClasses.Methods;

public class PasteTextInAJavaFileExecution extends AutoExecution {

	public PasteTextInAJavaFileExecution(String text) {
		super(text);
	}

	@Override
	public void execute() {
		//Copying the text from the constructor to the operating systems clipboard.
		Methods.copyToClipboard( getTitle() );
		//Open Active Editor.
		if( Methods.getActivePage().getActiveEditor() != null ){
			Methods.getActivePage().getActiveEditor().setFocus();
			Methods.threadSleep(50);
			//Execute paste command.
			Methods.executeCommand("org.eclipse.ui.edit.paste");
			Methods.threadSleep(50);
			Methods.simulateKeyboardKeyPress(SWT.SHIFT); //Just for getting through a KeyDown event.
		}else{
			MessageDialog.openError(null, "Error", "Please open a Java File!");
		}		
	}

}//end PasteTextInAJavaFileExecution.