package com.eclipse.listener.scenario.task.autocomplete;

import java.util.ArrayList;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Tree;
import org.eclipse.swt.widgets.TreeItem;

import com.eclipse.listener.helpClasses.Methods;
import com.eclipse.listener.helpClasses.ShellObjectIterator;

public class SelectTreeItemInNewWizardExecution extends AutoExecution {

	public SelectTreeItemInNewWizardExecution(String treeItemTitle) {
		super(treeItemTitle);
	}

	@Override
	public void execute() {
		if( getTitle().toLowerCase().equals("java project") ){
			//Open New-wizard.
			openNewWizard();
			//Select treeitem with text equals "java project".
			Methods.getDisplay().asyncExec(new Runnable() {
				public void run() {
					selectTreeItem(getTitle());
				}
			});				
		}
	}
	
	/**
	 * Help method for selecting a TreeItem in the active Shell.
	 * @param title
	 */
	private void selectTreeItem(String treeItemText) {
		//Thread sleep.
		Methods.threadSleep(500);
		
		//"New"-shell window er pent og aktivt.
		if( Methods.getCurrentlyOpenedDialogWindow() != null && Methods.getCurrentlyOpenedDialogWindow().getText().equals("New") ){
			System.out.println("Methods.getCurrentlyOpenedDialogWindow()!=null: " +Methods.getCurrentlyOpenedDialogWindow().getText() );
			//Bruke ShellObjectIterator til  hente ut alle Control-objects fra "New"-dialog window Shell.
			ShellObjectIterator shellObjectIterator = new ShellObjectIterator( Methods.getCurrentlyOpenedDialogWindow() );
			ArrayList<Control> shellControls = shellObjectIterator.getControls();
			if( shellControls != null ){
				System.out.println("[SelectTreeItemInNewWizardExecution]: ArrayList<Control> shellControls, size: " + shellControls.size());
				for (Control control : shellControls) {
					System.out.println("[SelectTreeItemInNewWizardExecution]: control: " +control);
					//Finne Tree-object i New-dialog window.
					if( control instanceof Tree ){
						System.out.println("[SelectTreeItemInNewWizardExecution]: control: " +control+ " is an instance of Tree!");
						final Tree tree = (Tree)control;
						TreeItem[] treeItems = tree.getItems();
						if( treeItems != null && treeItems.length > 0 ){
							for (int j = 0; j < treeItems.length; j++) {
								System.out.println("treeItems["+j+"]: "+ treeItems[j].getText()+ ", Shell: " +treeItems[j].getParent().getShell().getText() );
								if( treeItems[j].getText().equals(treeItemText) ){	//TreeItem Text. Ex: "Java Project".
									System.out.println("TreeItem: " +treeItems[j].getText()+ ", blir automatisk selected!");
									final TreeItem treeItem = treeItems[j];				
									tree.getShell().getDisplay().asyncExec (new Runnable () {
										public void run () {
											if(!tree.getShell().isDisposed()){
												Methods.getDisplay().setCursorLocation(Methods.getCoordinatesOfTreeItem(treeItem));
												tree.setSelection( treeItem ); //Denne alene setter markeringa til elementet, men label under select a wizard endres ikke.
												Event event = new Event();
												event.widget = tree;
												tree.notifyListeners(SWT.Selection, event);//Nr denne var med ble label under select a wizard endret til valgt treeItem.
											}
										}
								   });
									return;
								}
							}//for.
						}			
					}//Tree.
				}//foreach.
			}			
		}//end New.
		else{
			System.out.println("Current Dialog Window != null: " + (Methods.getCurrentlyOpenedDialogWindow() != null) );
			if( Methods.getCurrentlyOpenedDialogWindow() != null ){
				System.out.println("Current Dialog Window: " + Methods.getCurrentlyOpenedDialogWindow().getText());
			}
		}
	}//end selectTreeItem.
	
	/**
	 * Help method for opening the "new"-wizard.
	 */
	private void openNewWizard() {
		ToolBarClickExecution newWizardClick = new ToolBarClickExecution("New");
		newWizardClick.execute();	
	}

}//end SelectTreeItemInNewWizardExecution.