package com.eclipse.listener.scenario.task.autocomplete;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.widgets.ToolItem;

import com.eclipse.listener.helpClasses.Methods;

public class ToolBarClickExecution extends AutoExecution {

	public ToolBarClickExecution(String toolBarButton) {
		super(toolBarButton);
	}

	@Override
	public void execute() {
		Methods.getDisplay().asyncExec(new Runnable() {
			public void run() {		
				//Maximize Eclipse.
				Methods.getDisplay().getActiveShell().setMaximized(true);				
				Methods.threadSleep(300);	

				//Find the ToolItem.
				ToolItem toolItem = Methods.findToolItemInEclipseMainView( getTitle().toLowerCase() );
				if( toolItem != null ){
					//Coloring the background of the ToolItem's ToolBar.
					Color previous = toolItem.getParent().getBackground();
				    Color blue = Methods.getDisplay().getSystemColor(SWT.COLOR_BLUE);
				    for(int i=1; i<=5; i++) {
				    	Methods.threadSleep(250);
				    	toolItem.getParent().setBackground(blue);
				    	toolItem.getParent().update();
					    Methods.threadSleep(250);
					    toolItem.getParent().setBackground(previous);
					    toolItem.getParent().update();									    
					}
				    blue.dispose();
				    previous.dispose();
					
				    //Move the cursor on top of the ToolItem.
				    Methods.threadSleep(500);	
				    Methods.getDisplay().setCursorLocation(Methods.getCoordinatesOfToolItem(toolItem));
					
					//Simulate a mouse click.
				    Methods.threadSleep(500);
				    Methods.simulateMouseClick();			
				}		
			}//run.
		});			
	}//end execute.
}//end ToolBarClickExecution.