package com.eclipse.listener.scenario.task.autocomplete;

import java.util.ArrayList;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Tree;
import org.eclipse.swt.widgets.TreeItem;

import com.eclipse.listener.helpClasses.Methods;
import com.eclipse.listener.helpClasses.ShellObjectIterator;

public class TreeItemClickExecution2 extends AutoExecution {
	//Variables.
	private Listener showListener;
	
	public TreeItemClickExecution2(String treeItemTitle) {
		super(treeItemTitle);
	}

	@Override
	public void execute() {		
		if( getTitle().toLowerCase().equals("java build path") ){
			createShowListener();
			Methods.getDisplay().addFilter(SWT.Show, showListener); 
			//Execute tasks 1-3 for scenario 4.
			ContextMenuItemClickExecution scenario4 = new ContextMenuItemClickExecution("Properties");	
			scenario4.execute();			
		}//java build path.
		
	}//end execute.
	
	/**
	 * Method for listening after when a view/shell has been opened.
	 */
	public void createShowListener(){
		System.out.println("Create show listener!");
		showListener = new Listener() {			
			@Override
			public void handleEvent(Event event) {
				if( event.widget instanceof Shell ){
					Shell shell = (Shell)event.widget;
					System.out.println("Shell-showEvent: " + shell+ ", text: " + shell.getText());
					if( shell != null ){
						System.out.println("Shell: " + shell+ ", text: " +shell.getText());						
						Methods.getDisplay().asyncExec(new Runnable() {
							public void run() {
								System.out.println("RUN");
								selectTreeItem(getTitle());	//search and select treeitem.
							}
						});						
					}
				}				
			}
		};
	}// end createShowListener.
	
	/**
	 * Help method for selecting a TreeItem in the active Shell.
	 * @param title
	 */
	private void selectTreeItem(String treeItemText) {
		System.out.println("Select treeItem: " + treeItemText);
		//Thread sleep.
		Methods.threadSleep(200);
		
		if( Methods.getCurrentlyOpenedDialogWindow() != null ){
			System.out.println("Methods.getCurrentlyOpenedDialogWindow()!=null: " +Methods.getCurrentlyOpenedDialogWindow().getText() );
			//Bruke ShellObjectIterator til  hente ut alle Control-objects fra "New"-dialog window Shell.
			ShellObjectIterator shellObjectIterator = new ShellObjectIterator( Methods.getCurrentlyOpenedDialogWindow() );
			ArrayList<Control> shellControls = shellObjectIterator.getControls();
			if( shellControls != null ){
				System.out.println("[TreeItemClickExecution2]: ArrayList<Control> shellControls, size: " + shellControls.size());
				for (Control control : shellControls) {
					System.out.println("[TreeItemClickExecution2]: control: " +control);
					//Finne Tree-object i New-dialog window.
					if( control instanceof Tree ){
						System.out.println("[TreeItemClickExecution2]: control: " +control+ " is an instance of Tree!");
						final Tree tree = (Tree)control;
						TreeItem[] treeItems = tree.getItems();
						if( treeItems != null && treeItems.length > 0 ){
							for (int j = 0; j < treeItems.length; j++) {
								System.out.println("treeItems["+j+"]: "+ treeItems[j].getText()+ ", Shell: " +treeItems[j].getParent().getShell().getText() );
								if( treeItems[j].getText().equals(treeItemText) ){	//TreeItem Text. Ex: "Java Project".
									System.out.println("TreeItem: " +treeItems[j].getText()+ ", blir automatisk selected!");
									final TreeItem treeItem = treeItems[j];				
									tree.getShell().getDisplay().asyncExec (new Runnable () {
										public void run () {
											if(!tree.getShell().isDisposed()){
												Methods.getDisplay().removeFilter(SWT.Show, showListener); //remove listener
												System.out.println("Remove filter show-listener");
												Methods.getDisplay().setCursorLocation(Methods.getCoordinatesOfTreeItem(treeItem));
												tree.setSelection( treeItem ); //Denne alene setter markeringa til elementet, men label under select a wizard endres ikke.
												Methods.threadSleep(300);
												Event event = new Event();
												event.widget = tree;
												tree.notifyListeners(SWT.Selection, event);//Nr denne var med ble label under select a wizard endret til valgt treeItem.
											}
										}
								   });
									return;
								}
							}//for.
						}			
					}//Tree.
				}//foreach.
			}			
		}//end New.
		else{
			System.out.println("Current Dialog Window != null: " + (Methods.getCurrentlyOpenedDialogWindow() != null) );
			if( Methods.getCurrentlyOpenedDialogWindow() != null ){
				System.out.println("Current Dialog Window: " + Methods.getCurrentlyOpenedDialogWindow().getText());
			}
		}
	}//end selectTreeItem.
	
}//end TreeItemClickExecution2.